//@built-in
/////////////////////////////////////////////////////
precision highp float; 
precision highp int;

#define float2	vec2
#define float3	vec3
#define float4	vec4

#define float2L lowp vec2
#define float2M mediump vec2
#define float3L lowp vec3
#define float3M mediump vec3
#define float4L lowp vec4
#define float4M mediump vec4

#define matrix mat4
#define matrix33 mat3
#define samplerCB samplerCube
#define textureCB textureCube

#define saturate(_v) clamp(_v, 0.0, 1.0)
#define lerp(_a,_b,_r) mix(_a,_b,_r)


//@attribe
/////////////////////////////////////////////////////
#ifdef V_SHADER
attribute float4 POS0;
attribute float4 POS1;
attribute float4 POS2;
attribute float4 POS3;
attribute float4 NOR0;
attribute float4 NOR1;
attribute float4 NOR2;
//attribute float4 NOR3;
attribute float4 CLR0; 
attribute float4 CLR1; 
attribute float4 CLR2; 
//attribute float4 CLR3;
attribute float2 TUV0; 
attribute float2 TUV1; 
//attribute float2 TUV2; 
//attribute float2 TUV3; 
#endif


//@constant
/////////////////////////////////////////////////////
uniform highp mat4 c_mat0;	
uniform highp mat4 c_mat1;
uniform highp mat4 c_mat2;
uniform highp mat4 c_mat3;
uniform highp mat4 c_mat4;

uniform highp float4 c_parm0;
uniform highp float4 c_parm1;
uniform highp float4 c_parm2;
uniform highp float4 c_parm3;
uniform highp float4 c_parm4;
uniform highp float4 c_parm5;
uniform highp float4 c_parm6;
uniform highp float4 c_parm7;
uniform highp float4 c_parm8;
uniform highp float4 c_parm9;
uniform highp float4 c_parm10;
uniform highp float4 c_parm11;
uniform highp float4 c_parm12;
uniform highp float4 c_parm13;
uniform highp float4 c_parm14;
uniform highp float4 c_parm15;
uniform highp float4 c_parm16;
uniform highp float4 c_parm17;
uniform highp float4 c_parm18;
uniform highp float4 c_parm19;

#ifdef V_SHADER
#define matW			c_mat0
#define matVP			c_mat1
#define matWVP		c_mat2
#define matRot		c_mat3
#endif

#ifdef P_SHADER
uniform sampler2D c_samp0; 
uniform sampler2D c_samp1; 
uniform sampler2D c_samp2; 
uniform sampler2D c_samp3; 
uniform sampler2D c_samp4; 
uniform sampler2D c_samp5; 
uniform sampler2D c_samp6; 
uniform sampler2D c_samp7; 
uniform samplerCB c_cube; 
#endif


//@varying
/////////////////////////////////////////////////////
#define vs_out_p	gl_Position
#define ps_out_c	gl_FragColor

varying highp float4 v_array0;
varying highp float4 v_array1;
varying highp float4 v_array2;
varying highp float4 v_array3;
varying highp float4 v_array4;
varying highp float4 v_array5;
varying highp float4 v_array6;

varying mediump float4 v_array0M;
varying mediump float4 v_array1M;
varying mediump float4 v_array2M;
varying mediump float4 v_array3M;
varying mediump float4 v_array4M;
varying mediump float4 v_array5M;
varying mediump float4 v_array6M;

varying lowp float4 v_array0L;
varying lowp float4 v_array1L;
varying lowp float4 v_array2L;
varying lowp float4 v_array3L;
varying lowp float4 v_array4L;
varying lowp float4 v_array5L;
varying lowp float4 v_array6L;

	#define vs_out_0 	v_array0
	#define vs_out_1 	v_array1
	#define vs_out_2 	v_array2
	#define vs_out_3 	v_array3
	#define vs_out_4 	v_array4
	#define vs_out_5 	v_array5
	#define vs_out_6 	v_array6
	#define vs_out_7 	v_array7

	#define ps_in_0 	v_array0
	#define ps_in_1 	v_array1
	#define ps_in_2 	v_array2
	#define ps_in_3		v_array3
	#define ps_in_4 	v_array4
	#define ps_in_5 	v_array5
	#define ps_in_6 	v_array6
	#define ps_in_7 	v_array7



//@base
/////////////////////////////////////////////////////
#ifdef sd_Default
	#define UserColor		c_parm0
	#define GrayRatio		c_parm1.x
	#define FogNear			c_parm2.x					
	#define FogFar			c_parm2.y
	#define EyePos			c_parm3.xyz	
#endif


//@lynx
/////////////////////////////////////////////////////
#ifdef sd_Lynx
	#define SunDir							c_parm0.xyz	
	#define Ambient							c_parm0.w		
	#define SunColor						c_parm1.xyz	
	#define LambertPow					c_parm1.w		
	#define SpecRatio						c_parm2.x		
	#define ReflRatio						c_parm2.y		
	#define RimIntensity				c_parm2.w		
	#define RimBand							c_parm2.w		
	#define ShwColor						c_parm3
	#define EyePos							c_parm4.xyz	
	#define LitIntensity				c_parm4.w
	#define UserColor						c_parm5
#endif


//@Sea
/////////////////////////////////////////////////////
#ifdef sd_Sea
	#define EyePos					c_parm0.xyz
	#define SeaColor				c_parm1
	#define UV0Mul					(c_parm2.x)
	#define UV1Mul					(c_parm2.y)
	#define UV0Speed				(c_parm2.z*0.003)
	#define UV1Speed				(c_parm2.w*0.003)
	#define CTIME_MS				c_parm3.x
	#define NormalComp			c_parm3.y
	#define FresnelRatio		c_parm3.z
	#define FogNear					c_parm4.x
	#define FogFar					c_parm4.y
	#define LitIntensity		c_parm4.z
	#define NormalFading		c_parm5.xy

	#define SunColor				c_parm6.xyz
	#define Ambient					c_parm6.w
	#define ShwColor				c_parm7
#endif


//@Grass
/////////////////////////////////////////////////////
#ifdef sd_Grass
	#define CTIME_MS		c_parm0.x
	#define FogNear			c_parm2.x					
	#define FogFar			c_parm2.y
	#define EyePos			c_parm3.xyz	
#endif



//@functions
/////////////////////////////////////////////////////
float calc_distance (float3 spos, float3 dpos) {
	float4 tpos = float4(spos, 1.0) - float4(dpos, 1.0);
	return length(tpos);
}

float get_dis_alpha (float dist, float near_dist, float far_dist) {
	return saturate ( (far_dist - dist) / (far_dist - near_dist)  );
}

float3 calc_hemisphere (float3 vN, float3 vSky, float3 grwC, float3 skyC, float amb) {
	float dt = (dot(vN.xyz, vSky)+1.0)/2.0;
	return float3 ( lerp (grwC.xyz, skyC.xyz, dt)*amb);
}

float calc_diffuse (float3 vL, float3 vN, float power) {
	return pow ( 0.5+max(0.0, dot(vL,vN))*0.5, power );
}

float calc_rimlight (float3 vL, float3 vN, float3 vE, float intensity, float band) {
  float NV = saturate ( dot (vN, vE) );
  float rimpow = 1.0 + max( 0.0, dot(-vE, vL) );						
	return ( smoothstep ( -1.0+band, 1.0, 1.0-NV ) * rimpow * intensity );
}

float calc_specular (float3 vL, float3 vN, float3 vE, float intensity, float power) {
  float3 vH = normalize (vE + vL);
	return (intensity * pow (saturate(dot(vH, vN)), power ));
}


/**
 * calc point lights
 * 
 * @wP: world pos
 * @wN: world normal
 * @posL: xyz:light-pos, .w:range
 * @clrL: rgb:light-color, .w:power
 * @ret: .xyz:result_color, .w:spec
 */
float3 calc_point_light (float3 vP, float3 vN, float4 posL, float4 clrL) 
{
	float3 vL = (posL.xyz - vP.xyz);
	float density = saturate( 1.0 - length(float4(vL.xyz,0)) / (0.1+posL.w) );
				density = pow (density, clrL.w);

	vL = normalize (vL);
	float dt = (dot(vN, vL)+1.0)/2.0;

	return float3 (clrL.xyz * density * dt);
}


float3 calc_distance_light (float3 vP, float4 posL, float4 clrL) 
{
	float3 vL = (posL.xyz - vP.xyz);
	float density = saturate( 1.0 - length(float4(vL.xyz,0)) / (0.1+posL.w) );
				density = pow (density, 0.01+clrL.w);

	return float3 (clrL.xyz * density);
}

float4 calc_distance_lightX (float3 vP, float4 posL) 
{
	float3 vL = (posL.xyz - vP.xyz);
	float density = saturate( 1.0 - length(float4(vL.xyz,0)) / (0.1+posL.w) );
				density = pow (density, 3.0);//0.01+clrL.w);

	float3 ipos = normalize(-vL) * 0.5 * density * density;

	return float4 (ipos.xyz, density);
}

//pos.w: wave-range
float get_dis_wave (float3 vP, float4 wave_src)
{
	float4 tpos = float4(vP.xyz, 1.0) - float4(wave_src.xyz, 1.0);
	float dis = length(tpos);

	return 1.0 - saturate ( dis / wave_src.w  );
}
