
//@vs
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef V_SHADER

#define wP					POS0.xyz
#define wN					NOR0.xyz
#define _SpecRatio	TUV1.x
#define _ReflRatio	TUV1.y

void main () 
{	
	float3 ambc = float3 (Ambient, Ambient, Ambient);
	float sun_diff = calc_diffuse (SunDir, wN, LambertPow);
	float sun_spec = 0.0;
	float rim_diff = 0.0;

	float3 wE = normalize (EyePos - wP.xyz).xyz;
	sun_spec = calc_specular (SunDir, wN, wE, _SpecRatio, 30.0);
	rim_diff = calc_rimlight (SunDir, wN, wE, RimIntensity, RimBand);

	float3 diff = ambc.xyz + (sun_diff + sun_spec) * SunColor + ((1.0-sun_diff) * ShwColor.xyz * ShwColor.w) + float3(rim_diff, rim_diff, rim_diff);
	diff.xyz *= CLR0.xyz;

	vs_out_p = matVP * float4 (wP.xyz, 1.0);
	vs_out_0 = float4 (diff.xyz, CLR0.w);
	vs_out_1 = float4 (TUV0.xy, 0.0, 0.0);

#ifdef sd_LynxRefl
	vs_out_2 = float4 (reflect(-wE.xzy, wN.xzy), _ReflRatio);
#endif
}

#endif



//@ps
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef P_SHADER

	#define DiffColor		ps_in_0.xyzw
	#define TexUV				ps_in_1.xy
	#define ReflUV			ps_in_2.xyz
	#define ReflRat			ps_in_2.w

void main () 
{ 
	float4 texD = texture2D (c_samp0, TexUV ).xyzw;

#ifdef sd_LynxRefl
	float4 texR = textureCB (c_cube,  ReflUV ).xyzw;	 
	texD.xyz = lerp (texD.xyz, texD.xyz+texR.xyz, ReflRat);
#endif

	ps_out_c = float4 (texD.xyz*DiffColor.xyz, DiffColor.w * texD.w);
}

#endif







