//v0: xyzw:WorldPos
//v1: xy:NormalUV, zw:MaskUV
//v2: xyzw:ScreenPos


//@vs
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef V_SHADER

void main () 
{	
	float3 wP = (matW * POS0).xyz;					//world pos
	float dist = calc_distance (EyePos, wP);
	float fog = get_dis_alpha (dist, FogNear, FogFar);

//#ifdef sd_SeaDetail
	float2 normalUV = wP.xy / 500.0;
	float disR = get_dis_alpha (dist, NormalFading.x, NormalFading.y);
	float normal_comp = lerp (20.0, NormalComp, disR*disR);

	float uv0inc = CTIME_MS * UV0Speed;
	float uv1inc = CTIME_MS * UV1Speed;

	float3 color = SeaColor.xyz;// * CLR0.xyz;//diff;

	vs_out_p = (matVP * float4(wP, 1.0));	//screen pos
	vs_out_0 = float4 (color, SeaColor.w*fog*0.85);
	//vs_out_0 = float4 (color, fog);
	vs_out_1.xy = normalUV * UV0Mul + uv0inc;
	vs_out_1.zw = normalUV * UV1Mul - uv1inc;
	vs_out_3.xyz = normalize (EyePos - wP);
	vs_out_3.w = normal_comp;
}

#endif


//@ps
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef P_SHADER

#define WaterColor				ps_in_0
#define NormalUV00				ps_in_1.xy
#define NormalUV10				ps_in_1.zw
#define DownWaterUV				ps_in_2.xy
#define EyeDir						ps_in_3.xyz
#define NormalR						ps_in_3.w

#define samp_bump(_uv)			texture2D (c_samp0, _uv)
#define samp_fresnel(_uv)		texture2D (c_samp1, _uv)

void main () 
{ 
	float3 normal0 = samp_bump (NormalUV00).xyz * 2.0 - 1.0; normal0.z *= NormalR;

//#ifdef sd_Detail
//	float3 normal1 = samp_bump (NormalUV10).xyz * 2.0 - 1.0; normal1.z *= NormalR;
//	normal0 += normal1;
//#endif

	float3 wN		= normalize (normal0);
	float3 R		= reflect (-EyeDir.xzy, wN.xzy);
	float4 refl = textureCB (c_cube, R).xyzw;
	float f			= R.x * wN.x + R.y * wN.z + R.z * wN.y;

#ifdef sd_Detail
	f = samp_fresnel (float2(f, 0)).w;
#endif

#ifdef sd_Simple
	f = 1.0-f; f = pow (f, 10.0);
#endif

	float3 rcolor = lerp (WaterColor.xyz, refl.xyz, saturate (f+FresnelRatio));
	ps_out_c = float4 (rcolor, WaterColor.w);

}


#endif






